/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/23
 * Description 		    :
 *******************************************************************************/

#include "CH57x_common.h"

//#include "ch57x_soft_i2c.h"

#include <stdbool.h>

#include <oled.h>


/************GPIOŶ*****************************************/

//OLED
//#define IIC_SCL             GPIO_Pin_11
//#define IIC_SDA             GPIO_Pin_10
//#define OLED_RST            GPIO_Pin_12

//
#define Key0                GPIO_Pin_7      //Ӽ
#define Key1                GPIO_Pin_4      //
#define Key2                GPIO_Pin_23     //˵/趨
typedef enum
{
   Key_Add  =  00,          //Ӽ
   Key_Minus,               //
   Key_Set                  //˵/趨
}Key_Type;

//
#define Ralay_Ctrl          GPIO_Pin_14

//
#define Buzzer_Ctrl         GPIO_Pin_13

//ADCɼͨ
#define V_Adc               GPIO_Pin_5      //ѹɼ
#define I_Adc               GPIO_Pin_4      //ɼ
#define Temp                GPIO_Pin_12     //¶Ȳɼ


/************GPIO***************************************************/
void GPIO_Init(void)
{
//OLED
//GPIOB_ModeCfg(IIC_SCL|IIC_SDA, GPIO_ModeOut_PP_20mA);
//GPIOB_SetBits(IIC_SCL|IIC_SDA);
//GPIOB_ModeCfg(OLED_RST, GPIO_ModeOut_PP_20mA);
//GPIOB_SetBits(OLED_RST);              //ģIIC

  GPIOB_ModeCfg(GPIO_Pin_11|GPIO_Pin_10, GPIO_ModeOut_PP_20mA);
  GPIOB_SetBits(GPIO_Pin_11|GPIO_Pin_10);
  GPIOB_ModeCfg(GPIO_Pin_12, GPIO_ModeOut_PP_20mA);
  GPIOB_SetBits(GPIO_Pin_12);


//
GPIOA_ModeCfg(Ralay_Ctrl, GPIO_ModeOut_PP_5mA);
GPIOA_ResetBits(Ralay_Ctrl);                          //:,:.

//
GPIOA_ModeCfg(Buzzer_Ctrl, GPIO_ModeOut_PP_5mA);
GPIOA_ResetBits(Buzzer_Ctrl);                         //:,:.

}
/**********************************************************************/

/***********ADCʼ**************************************************/
void ADC_Init(void)
{
//ADCɼ
GPIOA_ModeCfg(V_Adc, GPIO_ModeIN_Floating);       //V_ADC
ADC_ChannelCfg(CH_EXTIN_1);
ADC_ExtSingleChSampInit(SampleFreq_3_2, ADC_PGA_0);


GPIOA_ModeCfg(I_Adc, GPIO_ModeIN_Floating);       //I_ADC
ADC_ChannelCfg(CH_EXTIN_0);
ADC_ExtSingleChSampInit(SampleFreq_3_2, ADC_PGA_0);

GPIOA_ModeCfg(Temp, GPIO_ModeIN_Floating);        //¶
ADC_ChannelCfg(CH_EXTIN_2);
ADC_ExtSingleChSampInit(SampleFreq_3_2, ADC_PGA_0);
}

/**********************************************************************/

/**********ʼ***************************************************/
void KEY_Init(void)
{
  //
  GPIOB_ModeCfg(Key0|Key1|Key2, GPIO_ModeIN_Floating);  //KEY0:+ ,KEY1:-,KEY2:/˵
}

/**********************************************************************/

void DebugInit( void )
{
  GPIOA_SetBits( GPIO_Pin_9 );
  GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeIN_PU );
  GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
  UART1_DefInit();
}

int main()
{
  UINT8 i;

  SetSysClock( CLK_SOURCE_PLL_32MHz );

  DebugInit();
  PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );
  PRINT("ch573/571 soft iic example\r\n");

  GPIO_Init();
  ch57x_soft_i2c_init();
  OLED_Init();


  while(1)
  {
    PRINT("while\r\n");
    GPIOA_InverseBits(Ralay_Ctrl);
    OLED_Clear();
    OLED_ShowChar(10, 10, 'A', 16);
    OLED_Refresh();
    mDelaymS(200);

    GPIOA_InverseBits(Ralay_Ctrl);

    OLED_Clear();
    OLED_ShowChinese(20,0,0,16);
    OLED_ShowChinese(36,0,1,16);
    OLED_ShowChinese(52,0,2,16);
    OLED_ShowChinese(0,20,3,16);
    OLED_ShowChinese(16,20,4,16);
    OLED_ShowChinese(32,20,5,16);
    OLED_ShowChinese(48,20,6,16);
    OLED_ShowChinese(64,20,7,16);
    OLED_Refresh();
    GPIOA_InverseBits(Ralay_Ctrl);
    mDelaymS(200);

    GPIOA_InverseBits(Ralay_Ctrl);

    OLED_Clear();
    OLED_ShowChinese(10,0,0,24);
    OLED_ShowChinese(34,0,1,24);
    OLED_ShowChinese(58,0,2,24);
    OLED_ShowChinese(0,30,3,24);
    OLED_ShowChinese(24,30,4,24);
    OLED_ShowChinese(48,30,5,24);
    OLED_ShowChinese(72,30,6,24);
    OLED_ShowChinese(96,30,7,24);
    OLED_Refresh();

    mDelaymS(100);


  }
}



